module UserCenter
  class Retry

    def self.query(&_proc)
      value = nil

      if block_given?
        begin
          4.times do
            Rails.logger.info "user_center_retry_query: #{Time.now.strftime("%Y-%m-%d %H:%M:%S-%L")}"

            value = _proc.call
            break if value.present?

            sleep 0.8
          end
        rescue => e
          Rails.logger.info "retry_query_error is #{e.inspect} 数据库连接数已超！"
        end
      end

      value
    end

    def self.uncached_query(&_proc)
      value = nil

      if block_given?
        begin
          4.times do
            Rails.logger.info "user_center_retry_query: #{Time.now.strftime("%Y-%m-%d %H:%M:%S-%L")}"

            value = ActiveRecord::Base.uncached { _proc.call }
            break if value.present?

            sleep 0.8
          end
        rescue => e
          Rails.logger.info "retry_query_error is #{e.inspect}  数据库连接数已超！"
        end
      end

      value
    end

  end
end