module UserCenter
  module Services
    class LoginServices

      def initialize(opts)

      end

      def login
        Trans::Router.login_url
      end

      def vertify(ticket)
        opts = {
          ticket: ticket
        }

        res = Trans::HttpHandler.post(Trans::Router.verify_ticket_url, opts)
      end

      def app_users_login(phone: , email: , password: , corp_id: '')
        opts = {
          phone: phone,
          email: email,
          password: password,
          corpId: corp_id
        }

        res = Trans::HttpHandler.post(Trans::Router.app_users_login_url, opts)
      end

      def open_api_login(phone: , email: , password: , corp_id: '')
        opts = {
          phone: phone,
          email: email,
          password: password,
          corpId: corp_id
        }

        res = Trans::HttpHandler.post(Trans::Router.sso_open_api_login_url, opts)
      end

      def app_org_list(phone)
        opts = {
          phone: phone
        }

        res = Trans::HttpHandler.get(Trans::Router.app_phone_list, opts)

        if res[:code].to_s == '0'
          org_oids = res[:data].map{|org| org[:oid] }
          Organization.where(oid: org_oids).select(:name, :corp_id).map {|o| {name: o.name, corp_id: o.corp_id} }
        else
          []
        end
      end

      def user_info(user_token)
        opts = {
          curUserToken: user_token
        }

        res = Trans::HttpHandler.get(Trans::Router.user_info_url, opts)
      end
    end
  end
end