module UserCenter
  module Services
    class UserRegisterService

      APP_HEADER = { "appToken" => CrossSites[:user_center]['app_token'], "accessToken" => CrossSites[:user_center]['access_token'] }

      def initialize(opts)
      end

      def allow_register?(phone: )
        res = check_user(phone: phone)
        logger_info("allow_register? phone: #{phone} res: #{res}")

        return (res && res[:code].to_i == 0) ? res[:data][:register] : false
      end

      def register(params)
        res = organization_register(params)
        logger_info("register params: #{params} res: #{res}")

        return (res && res[:code].to_i == 0) ? res[:data][:uid] : nil
      end

      def check_user(phone: )
        opts = {
          phone: phone
        }

        res = Trans::HttpHandler.get(Trans::Router.check_user_url, opts)
      end

      def organization_register(params)
        _url = Trans::Router.organization_register_url
        _params = {
          phone: params[:phone],
          organizationName: params[:company_name],
          userName: params[:name],
          passwordOne: params[:password],
          passwordTwo: params[:password],
          registeredWay: params[:register_way],
          job: params[:job],
          email: params[:email]
        }

        res = Trans::HttpHandler.post(_url, _params, APP_HEADER)
      end

      private
      def logger_error(msg, uuid = nil)
        ::UserCenter::UcLogger.log_error("UserRegisterService #{msg}", uuid: uuid)
      end

      def logger_info(msg, uuid = nil)
        ::UserCenter::UcLogger.log_info("UserRegisterService #{msg}", uuid: uuid)
      end
    end
  end
end