module UserCenter
  module Services
    module Wx
      class LoginService
        LOGIN_CALLBACK_URL = CrossSites['user_center']['login_callback_url']

        def initialize(opts)

        end

        def get_corp_id(oid)
          opts = {
            oid: oid
          }

          Trans::HttpHandler.get(Trans::Router.get_corp_id_url, opts)
        end

        def qr_code_login
          opts = {
            successUrl: LOGIN_CALLBACK_URL
          }

          Trans::HttpHandler.get(Trans::Router.qrcode_login_url, opts)
        end

        def login(corpId, code)
          opts = {
            corpId: corpId,
            code: code
          }

          Trans::HttpHandler.get(Trans::Router.get_user_info_by_code_url, opts)
        end

        # 企业微信服务商后台点击进入
        def sso_login(authcode)
          opts = {
            authCode: authcode
          }

          Trans::HttpHandler.get(Trans::Router.get_login_info_by_auth_code_url, opts)
        end

        def get_jsapi_signature(oid, noncestr, timestamp, url, get_provider: false)
          opts = {
            oid: oid,
            noncestr: noncestr,
            timestamp: timestamp,
            url: url,
            getProvider: get_provider
          }

          Trans::HttpHandler.get(Trans::Router.get_jsapi_signature_url, opts)
        end

        def get_jsagent_signature_url(oid, noncestr, timestamp, url)
          opts = {
            oid: oid,
            noncestr: noncestr,
            timestamp: timestamp,
            url: url
          }

          Trans::HttpHandler.get(Trans::Router.get_jsagent_signature_url, opts)
        end
      end
    end
  end
end