module CrmUc
  module OrganizationRoleable
    extend ActiveSupport::Concern

    included do
    end

    def super_role
      @super_role ||= roles.detect{|r| r.settings["internal"]}
    end

    def super_users
      @super_users ||= (super_role ? super_role.users : User.none)
    end

    def super_user_ids
      @super_user_ids ||= super_users.pluck(:id)
    end

    def normal_manager_role
      @normal_manager_role ||= roles.find &:normal_manager_role?
    end

    def normal_managers
      @normal_managers ||= (normal_manager_role ? normal_manager_role.users : User.none)
    end

    module ClassMethods
    end
  end
end
