module CrmUc
  module OrganizationUserable
    extend ActiveSupport::Concern

    included do
    end

    def all_staffs
      if AppSettings.uc_enabled?
        users
      else
        users.where(locked_at: nil)
      end
    end

    def strictly_staffs
      users.leaves.with_organization_staff_state
    end

    def all_active_staffs
      if AppSettings.uc_enabled?
        all_staffs.joins(:user_extra).where(user_extras: {last_sign_in_at: 6.months.ago..Time.now})
      else
        all_staffs.where(last_sign_in_at: 6.months.ago..Time.now)
      end
    end

    def all_inactive_staffs
      if AppSettings.uc_enabled?
        all_staffs.joins(:user_extra).where("user_extras.last_sign_in_at < ?", 6.months.ago)
      else
        all_staffs.where("last_sign_in_at < ?", 6.months.ago)
      end
    end

    module ClassMethods
    end
  end
end
